Subject: Re: Workflow example for remote repository use of GIT

From: Shawn Pearce <[email-masked]>
Date: Tue, 28 Nov 2006 10:25:24 -0500

Sean Kelley <[email-masked]> wrote:
> I have been trying to set-up a workflow for developers in my group
> using GIT. I came up with this simplified flow.  Do you all see any
> problems with this approach?
...
> Always work out of master
> 
>  git checkout master
> 
> Getting The Latest Upstream Code into master
> 
>  git pull origin master
> 
> Create a topic branch for your development work
> 
>  git checkout -b <new topic branch name>

That can be streamlined slightly:

  git fetch
  git checkout -b <new-topic> origin

as fetch would by default download from remote 'origin' and update
the tracking branches.  And of course developers may not want to
create their new branch from origin, e.g. if they are doing a bug
fix to an earlier release of the product.  I think its a good habit
to be in to always specify the origination point for a branch when
creating it.
 
> Do your development in the topic branch
> 
>  edit/debug/test
> 
> Committing Changes
> 
>  git commit -a

Sure, that's CVS-like and rather simple.
 
> Switch back to master
> 
>  git checkout master
> 
> Update the master branch from origin again
> 
>  git pull origin master
> 
> Now Merge your topic branch
> 
>  git pull . <topic branch to merge into current branch>

Yes, that works and will get you a merge message like

  Merge branch 'my-topic' into master

which is probably what you want if there actually was a merge.
If there wasn't (its just a fast-forward) then you won't get the
merge message.  It also has the nice property that the "trunk (if
there is such a thing)" is the first parent in every merge, with
the topic(s) in the other parents.

Though I tend to just pull the origin into the current branch
and push that directly, e.g.:

  git pull origin master
  git push origin HEAD:master

--